Attribute VB_Name = "mNativeTODO"
Option Explicit

'Untested native reg api

Private Declare Function NtLoadKey Lib "ntdll.dll" (regKey As OBJECT_ATTRIBUTES, _
                hiveFile As OBJECT_ATTRIBUTES) As Long
Private Declare Function NtUnLoadKey Lib "ntdll.dll" (regKey As OBJECT_ATTRIBUTES) As Long

Public Function NativeLoadKey(ByVal rootKey As RegRootKeys, ByVal SubKey As String, ByVal FilePath As String) As Long
   Dim hKey As Long, ret As Long
   ret = NativeOpenKey(rootKey, "SOFTWARE", KEY_READ + KEY_WRITE + KEY_CREATE_SUB_KEY, hKey)
   If ret Then
      NativeLoadKey = RtlNtStatusToDosError(ret)
      Exit Function
   End If
   Dim usPath As UNICODE_STRING, usHive As UNICODE_STRING
   Dim oaKey As OBJECT_ATTRIBUTES, oaFile As OBJECT_ATTRIBUTES
   Call DosPathToNTPath(FilePath, usPath)
   RtlInitUnicodeStringVB usHive, SubKey
   InitializeObjectAttributes oaFile, usPath, OBJ_CASE_INSENSITIVE, 0, 0
   InitializeObjectAttributes oaKey, usHive, OBJ_CASE_INSENSITIVE, hKey, 0
   ret = NtLoadKey(oaKey, oaFile)
   If ret Then NativeLoadKey = RtlNtStatusToDosError(ret)
   NativeCloseKey hKey
End Function
Public Function NativeLoadKeyPath(ByVal regPath As String, ByVal SubKey As String, ByVal FilePath As String) As Long
   Dim hKey As Long, hSubKey As Long, ret As Long
   ret = NativeOpenPath(regPath, KEY_READ Or KEY_CREATE_SUB_KEY, hKey)
   If ret Then
      NativeLoadKeyPath = RtlNtStatusToDosError(ret)
      Exit Function
   End If
   ret = NativeCreateSubKey(hKey, SubKey, KEY_ALL_ACCESS, REG_OPTION_BACKUP_RESTORE, hSubKey)
   Dim usPath As UNICODE_STRING, usHive As UNICODE_STRING
   Dim oaKey As OBJECT_ATTRIBUTES, oaFile As OBJECT_ATTRIBUTES
   RtlInitUnicodeStringVB usPath, FilePath
   RtlInitUnicodeStringVB usHive, SubKey
   InitializeObjectAttributes oaFile, usPath, OBJ_CASE_INSENSITIVE, 0, 0
   InitializeObjectAttributes oaKey, usHive, OBJ_CASE_INSENSITIVE, hKey, 0
   ret = NtLoadKey(oaKey, oaFile)
   If ret Then NativeLoadKeyPath = RtlNtStatusToDosError(ret)
   NativeCloseKey hSubKey
   NativeCloseKey hKey
End Function

Public Function NativeUnLoadKey(ByVal rootKey As RegRootKeys, ByVal SubKey As String) As Long
   Dim hKey As Long, ret As Long
   ret = NativeOpenKey(rootKey, "", KEY_ALL_ACCESS, hKey)
   If ret Then
      NativeUnLoadKey = RtlNtStatusToDosError(ret)
      Exit Function
   End If
   Dim usHive As UNICODE_STRING
   Dim oaKey As OBJECT_ATTRIBUTES
   RtlInitUnicodeStringVB usHive, SubKey
   InitializeObjectAttributes oaKey, usHive, OBJ_CASE_INSENSITIVE, hKey, 0
   ret = NtUnLoadKey(oaKey)
   If ret Then NativeUnLoadKey = RtlNtStatusToDosError(ret)
   NativeCloseKey hKey
End Function
Public Function NativeUnLoadKeyPath(ByVal regPath As String, ByVal SubKey As String) As Long
   Dim hKey As Long, ret As Long
   ret = NativeOpenPath(regPath, KEY_ALL_ACCESS, hKey)
   If ret Then
      NativeUnLoadKeyPath = RtlNtStatusToDosError(ret)
      Exit Function
   End If
   Dim usHive As UNICODE_STRING
   Dim oaKey As OBJECT_ATTRIBUTES
   RtlInitUnicodeStringVB usHive, SubKey
   InitializeObjectAttributes oaKey, usHive, OBJ_CASE_INSENSITIVE, hKey, 0
   ret = NtUnLoadKey(oaKey)
   If ret Then NativeUnLoadKeyPath = RtlNtStatusToDosError(ret)
   NativeCloseKey hKey
End Function

